/*<Header>==============================================================
*
*	CLIP MANAGER / "EIN_CLP1.C"
*
*		[ EIN(tm) project : EBhDNbv⏕֐Q ]
*
*	COPYRIGHT  Nam & OZZY  1994, All rights reserved.
*
*-----------------------------------------------------------------------
*	V1.0L01	94.07.08/Nam	vg^Cv(OZZY̊֐𗘗p)
*</Header>==============================================================*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<snd.h>
#include	<winb.h>
#include	<te.h>
#include	<fntb.h>
#include	<gui.h>
#include	<egb.h>
#include	<msdos.cf>
#include	<loader.h>
#include	<math.h>
#include	<io.h>
#include	<guidbg.h>

#define	EIN_CLIP
#include	"..\eintm.h"

#ifndef NOERR
#define	NOERR	(0)
#endif
#ifndef ERROR
#define	ERROR	(1)
#endif

/* Nbvf[^\ */
typedef struct {
	WINCLIP		*clip;
	WINCLIP		*visible;
	POINT		svPos;
}	EIN_CLIPWORK;						/* Nbvf[^\ */

/*<Func>================================================================
*	int		EIN_clipOpen( char *work )
*
*	yT  vz	EBhENbvSʉ
*
*	y@  \z	s֐EBhEgSʂɂ
*
*	y  ́z	*work		:	Nbvޔp[N
*
*	yo  ́z
*
*	y֐lz	== NOERR	I
*
*	y  Ӂz	I EIN_clipClose() Ăяoĉ
*
*	ygpz
*				char		clp[EINCLIPSIZE];
*
*				EIN_clipOpen( cl );
*				MG_mosDisp(2);
*				WGB_putBlock( guiEgbPtr, 3, (char *)&put ) ;
*				MG_mosDisp(3);
*				EIN_clipClose( clp );
*
*-----------------------------------------------------------------------
*	V11L10	1994.07.08/Nam	(OZZY̊֐)
*</Func>==============================================================*/
int		EIN_clipOpen( EIN_CLIPWORK *p )
{
	WINCLIP	*pwclp ;
	WINCTRL	*pctrl ;
	POINT	pos ;

	/* 񑩂ErrorTrap */
	if ( p == NULL ){
		return ERROR;
	}
	/*	Wn̈ꎞύX	*/
	pos.x = 0 ; pos.y = 0 ;
	MG_PushOrigin( &pos, &p->svPos ) ;

	/*	ʑŜ̃TCY擾	*/
	MMI_GetControl( &pctrl ) ;
	pwclp = WIN_getClipMemory( &( pctrl->bound ), NULL ) ;

	/*	\gݒ肷.	*/
	WIN_pushVisible( WIN_copyClip( pwclp ), &p->visible ) ;
	WIN_pushClip( pwclp, &p->clip ) ;

	return NOERR ;
}

/*<Func>================================================================
*	int		EIN_clipClose( char *work )
*
*	yT  vz	EBhENbvSʉ
*
*	y@  \z	s֐EBhEgSʉ
*
*	y  ́z	*work		:	Nbvޔp[N
*
*	yo  ́z	Ȃ
*
*	y֐lz	== NOERR	I
*
*	y  Ӂz	EIN_clipOpen() ̌ŌĂяoĉ
*
*	yQ  Ɓz	
*
*-----------------------------------------------------------------------
*	V11L10	1994.07.08/Nam	(OZZY̊֐)
*</Func>==============================================================*/
int		EIN_clipClose( EIN_CLIPWORK *p )
{
	/* 񑩂ErrorTrap */
	if ( p == NULL ){
		return ERROR;
	}
	/*	\g𕜋A.	*/
	WIN_popClip( p->clip ) ;
	WIN_popVisible( p->visible );
	/* Wn̕A */
	MG_PopOrigin( &p->svPos );

	return NOERR ;
}

